<template>
  <v-dialog scrollable v-model="toShow" width="65%">
    <v-form v-show="isLoad" v-model="valid">
      <v-card>
        <!-- <v-card-title> -->
        <v-toolbar dark color="primary">
          <v-text-field
            solo
            flat
            background-color="primary"
            :rules="[validationRules.required, validationRules.counter30]"
            v-model="data.fatherTask.title"
            :readonly="!editTitle"
            class="title"
            style="margin-top:auto; font-size: 2em !important;"
          >
            <template v-slot:append-outer>
              <v-slide-x-reverse-transition mode="out-in">
                <v-icon
                  :key="`icon-${editTitle}`"
                  :color="editTitle ? 'success' : 'info'"
                  @click="editTitle = !editTitle"
                  v-text="
                    editTitle ? 'mdi-check-outline' : 'mdi-circle-edit-outline'
                  "
                ></v-icon>
              </v-slide-x-reverse-transition>
            </template>
          </v-text-field>
          <v-spacer></v-spacer>
          <v-btn icon dark @click="toShow = false">
            <v-icon>mdi-close</v-icon>
          </v-btn>
          <v-btn :disabled="!valid" dark text @click="onSave">שמור</v-btn>
        </v-toolbar>
        <!-- </v-card-title> -->
        <v-card-text class="pa-0">
          <v-container class="grey lighten-5">
            <v-row justify="center">
              <v-col cols="2" sm="4">
                <v-select
                  :rules="[validationRules.required]"
                  v-model="data.fatherTask.domain_id"
                  class="rtl"
                  :items="domains"
                  item-text="name"
                  item-value="id"
                  solo
                ></v-select>
              </v-col>
            </v-row>
            <v-row>
              <v-col class="text-center" cols="3" sm="3">
                <h4>:דדליין</h4>
                <v-menu v-model="deadlineMenu" transition="scale-transition">
                  <template v-slot:activator="{ on, attrs }">
                    <v-text-field
                      class="deadline"
                      v-model="computedDeadLineFormatted"
                      prepend-icon="event"
                      readonly
                      v-bind="attrs"
                      v-on="on"
                    ></v-text-field>
                  </template>
                  <v-date-picker
                    locale="he-IL"
                    v-model="data.fatherTask.deadline"
                    @input="deadlineMenu = false"
                  ></v-date-picker>
                </v-menu>
              </v-col>
              <v-col class="text-center" cols="6" sm="6">
                <h4>:דחיפות</h4>
                <v-btn-toggle
                  v-model="data.fatherTask.urgency"
                  :color="
                    data.fatherTask.urgency == urgencies[0]
                      ? 'green'
                      : data.fatherTask.urgency == urgencies[1]
                      ? 'orange'
                      : 'red'
                  "
                >
                  <v-btn
                    v-for="urgency in urgencies"
                    :key="urgency"
                    :value="urgency"
                    >{{ urgency }}</v-btn
                  >
                </v-btn-toggle>
              </v-col>
              <v-col class="text-center" cols="3" sm="3">
                <h4>:סטטוס</h4>
                <v-chip
                  label
                  :color="
                    data.fatherTask.status == statuses[0]
                      ? 'yellow'
                      : data.fatherTask.status == statuses[1]
                      ? 'primary'
                      : 'green'
                  "
                  >{{ data.fatherTask.status }}</v-chip
                >
              </v-col>
            </v-row>
            <v-row class="rtl">
              <v-col cols="4" sm="8">
                <v-textarea
                  :rules="[
                    validationRules.required,
                    validationRules.counter300,
                  ]"
                  solo
                  v-model="data.fatherTask.description"
                ></v-textarea>
              </v-col>
            </v-row>
            <v-row justify="center">
              <h2 style="text-decoration: underline">משימות</h2>
            </v-row>
            <taskCard
              v-for="task in data.tasks"
              :key="task.id"
              class="mb-10"
              :initial-task="task"
              @on-task-save="onTaskSave"
              @on-task-delete="onTaskDelete"
            ></taskCard>
            <v-row justify="center">
              <v-col cols="12" class="text-center">
                <v-btn
                  :disabled="!('id' in data.fatherTask)"
                  color="success"
                  fab
                  large
                  dark
                  @click="
                    data.tasks.push({
                      id: -(Math.floor(Math.random() * 100) + 1),
                      title: '',
                      description: '',
                      crew: [],
                      start: null,
                      end: null,
                    })
                  "
                >
                  <v-icon>mdi-plus</v-icon>
                </v-btn>
              </v-col>
            </v-row>
          </v-container>
        </v-card-text>
      </v-card>
    </v-form>
    <v-card color="primary" dark v-show="!isLoad">
      <v-card-text>
        <div class="text-right">טוען נתונים</div>
        <v-progress-linear
          indeterminate
          color="white"
          class="mb-0"
        ></v-progress-linear>
      </v-card-text>
    </v-card>
    <vue-confirm-dialog></vue-confirm-dialog>
  </v-dialog>
</template>

<script>
import { mapGetters, mapActions } from "vuex";
import taskCard from "./taskCard";
import axios from "axios";
import { api_base_url } from "../config";

export default {
  components: { taskCard },
  computed: {
    ...mapGetters("metadata", [
      "domains",
      "taskTypes",
      "urgencies",
      "statuses",
    ]),
    // ...mapGetters("fatherTaskDialog", ["isLoad", "data"]),
    // toShow: {
    //   get() {
    //     return this.$store.state.fatherTaskDialog.toShow;
    //   },
    //   set() {
    //     this.hide();
    //   }
    // },
    computedDeadLineFormatted() {
      return this.formatDate(this.data.fatherTask.deadline);
    },
  },
  methods: {
    // ...mapActions("fatherTaskDialog", ["show", "hide"]),
    ...mapActions(["updateTask", "createTask", "deleteTask"]),
    formatDate(date) {
      if (!date) return null;

      const [year, month, day] = date.split("-");
      return `${day}/${month}/${year}`;
    },
    onSave() {
      const updFatherTask = this.data.fatherTask;
      if (updFatherTask.id) {
        axios
          .put(api_base_url + "father-task", updFatherTask)
          .catch((error) => {
            window.alert(error);
          });
        this.toShow = false;
      } else {
        axios
          .post(api_base_url + "father-task", updFatherTask)
          .then((response) => {
            this.data.fatherTask = response.data;
          })
          .catch((error) => {
            window.alert(error);
          });
      }
    },
    onTaskSave(updTask) {
      if (updTask.id > 0) {
        this.updateTask(updTask);
      } else {
        updTask["father_id"] = this.data.fatherTask.id;
        this.createTask(updTask).then((createdTask) => {
          const index = this.data.tasks.findIndex(
            (task) => task.id === updTask.id
          );
          if (index !== -1) {
            this.data.tasks.splice(index, 1, createdTask);
          }
        });
      }
    },
    onTaskDelete(id) {
      this.$confirm({
        message: `האם אתה רוצה למחוק את המשימה?`,
        button: {
          no: "לא",
          yes: "כן",
        },
        callback: (confirm) => {
          if (confirm) {
            this.data.tasks = this.data.tasks.filter((task) => task.id !== id);
            this.deleteTask(id);
          }
        },
      });
    },
  },
  mounted() {
    this.$root.$on("call-father-task-dialog", (fatherTaskID) => {
      if (fatherTaskID) {
        this.isLoad = false;
        this.editTitle = false;
        this.toShow = true;
        axios
          .get(api_base_url + `father-task/with-childs/${fatherTaskID}`)
          .then(
            (response) => {
              this.data.fatherTask = response.data.father_task;
              this.data.tasks = response.data.tasks;
              this.isLoad = true;
            },
            (error) => {
              this.toShow = false;
              window.alert(error, "fatherTask");
            }
          );
      } else {
        this.data = {
          fatherTask: { title: "", description: "", urgency: "רגיל" },
          tasks: [],
        };
        this.editTitle = true;
        this.isLoad = true;
        this.toShow = true;
      }
    });
  },
  data() {
    return {
      data: { fatherTask: { title: "", description: "" }, tasks: [] },
      deadlineMenu: false,
      toShow: false,
      isLoad: false,
      valid: false,
      editTitle: false,
      validationRules: {
        required: (value) => !!value || "שדה חובה",
        counter30: (value) => value.length <= 30 || "עד 30 תווים",
        counter300: (value) => value.length <= 300 || "עד 300 תווים",
      },
    };
  },
  // watch: {
  //   // whenever data in store changed(on new click), local data will update
  //   data: function(newData) {
  //     this.data = newData;
  //   }
  // }
};
</script>

<style computed>
.deadline {
  direction: ltr;
  width: 110px;
  margin-right: auto;
  margin-left: auto;
  margin-top: 10px;
  padding-top: 0;
}

.deadline .v-input__icon--prepend .v-icon {
  color: #1976d2;
}

.title .v-messages {
  margin-top: 10px;
}
</style>
